## innoextract 1.2+git20120504

=== debian/changelog ===
innoextract (1.2+git20120504-1) unstable; urgency=low

  * Initial release. (Closes: #678294)

 -- Lennart Weller <lhw@ring0.de>  Wed, 20 Jun 2012 18:12:47 +0200
