=== debian/control ===
Source: innoextract
Section: utils
Priority: extra
Maintainer: Lennart Weller <lhw@ring0.de>
Uploaders: Sebastian Reichel <sre@debian.org>
Standards-Version: 3.9.3
Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/innoextract.git
Homepage: https://github.com/dscharrer/InnoExtract
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-iostreams-dev,
               libboost-filesystem-dev,
               libboost-date-time-dev,
               libboost-system-dev,
               libboost-program-options-dev,
               liblzma-dev

Package: innoextract
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tool for extracting data from an Inno Setup installer
 Inno Setup is a tool to create installers for Microsoft Windows applications.
 Inno Extracts allows one to extract such installers under non-windows systems
 without running the actual installer using wine. Inno Extract currently
 supports installers created by Inno Setup 1.2.10 to 5.4.3.
