## innoextract 1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 include(CheckSymbolExists)
 include(BuildType)
 include(StyleCheck)
+include(Doxygen)
 include(TestBigEndian)
 
 # Force re-checking libraries if the compiler or compiler flags change.
@@ -53,6 +54,8 @@
 list(APPEND LIBRARIES "${Boost_LIBRARIES}")
 link_directories("${Boost_LIBRARY_DIRS}")
 include_directories(SYSTEM "${Boost_INCLUDE_DIR}")
+
+add_cxxflag("-std=c++11")
 
 add_cxxflag("-Wall")
 add_cxxflag("-Wextra")
@@ -157,8 +160,9 @@
 
 configure_file("src/configure.hpp.in" "configure.hpp")
 
-set(VERSION_FILE "${CMAKE_BINARY_DIR}/version.cpp")
-version_file("src/version.cpp.in" "${VERSION_FILE}" "VERSION" ".git")
+file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/cli")
+set(VERSION_FILE "${CMAKE_BINARY_DIR}/cli/version.cpp")
+version_file("src/cli/version.cpp.in" "${VERSION_FILE}" "VERSION" ".git")
 list(APPEND INNOEXTRACT_SOURCES "${VERSION_FILE}")
 
 add_executable(innoextract ${INNOEXTRACT_SOURCES} ${ALL_INCLUDES})
@@ -171,3 +175,5 @@
 # Additional targets.
 
 add_style_check_target(style "${INNOEXTRACT_SOURCES}" "${ALL_INCLUDES}")
+
+add_doxygen_target(doc "doc/Doxyfile.in" "VERSION" ".git" "${CMAKE_BINARY_DIR}/doc")
