=== debian/changelog ===
innoextract (1.3-1build1) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:41 +0100

innoextract (1.3-1) unstable; urgency=low

  * New upstream release
  * Update Debian Standards Version to 3.9.4

 -- Lennart Weller <lhw@ring0.de>  Thu, 25 Oct 2012 23:01:31 +0200

innoextract (1.2+git20120504-2) unstable; urgency=low

  * introduced hardening to the binary to solve all warnings

 -- Lennart Weller <lhw@ring0.de>  Thu, 04 Oct 2012 23:05:27 +0200
