=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: innoextract
 Section: utils
 Priority: extra
-Maintainer: Lennart Weller <lhw@ring0.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/innoextract.git
 Homepage: https://github.com/dscharrer/InnoExtract
 Build-Depends: cmake,
                debhelper (>= 9),
+               dpkg-dev (>= 1.16.1~),
                libboost-iostreams-dev,
                libboost-filesystem-dev,
                libboost-date-time-dev,
