=== debian/changelog ===
innoextract (1.4-1) unstable; urgency=low

  * New upstream release (Closes: #730524)

 -- Lennart Weller <lhw@ring0.de>  Wed, 27 Nov 2013 15:42:57 +0100
