=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: innoextract
 Section: utils
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Lennart Weller <lhw@ring0.de>
+Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
 Standards-Version: 3.9.4
 Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git
