=== debian/watch ===
version=3
opts="uversionmangle=s/^v//" \
http://githubredir.debian.net/github/dscharrer/InnoExtract/(.+)\.tar\.gz
