## innoextract 1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,11 +5,20 @@
 
 # Define configuration options
 
-option(USE_LZMA "Build lzma decompression support." ON)
+option(USE_LZMA "Build lzma decompression support" ON)
+set(WITH_CONV CACHE STRING "The library to use for charset conversions")
+option(ENABLE_BUILTIN_CONV "Build internal charset conversion routines" ON)
 option(DEBUG_EXTRA "Expensive debug options" OFF)
 option(SET_WARNING_FLAGS "Adjust compiler warning flags" ON)
 option(SET_OPTIMIZATION_FLAGS "Adjust compiler optimization flags" ON)
 option(USE_CXX11 "Try to use C++11 if available" ON)
+option(USE_DYNAMIC_UTIMENSAT "Dynamically load utimensat if not available at compile time" OFF)
+if(NOT DEFINED DEBUG AND CMAKE_BUILD_TYPE STREQUAL "Debug")
+	set(DEBUG 1)
+endif()
+if(DEBUG)
+	add_definitions(-DDEBUG=1)
+endif()
 
 set(default_USE_STATIC_LIBS OFF)
 if(WIN32)
@@ -48,8 +57,10 @@
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake") # For custom cmake modules
 include(BuildType)
 include(CompileCheck)
+include(CreateSourceGroups)
 include(CXX11Check)
 include(Doxygen)
+include(FilterList)
 include(PrintConfiguration)
 include(StyleCheck)
 include(UseStaticLibs)
@@ -64,11 +75,6 @@
 	add_definitions(-D_WIN32_WINNT=0x0502)
 	add_definitions(-DNOMINMAX)
 	add_definitions(-DWIN32_LEAN_AND_MEAN)
-	if(NOT MSVC)
-		 # required for _gmtime64_s on MinGW
-		add_definitions(-DMINGW_HAS_SECURE_API)
-		list(APPEND CMAKE_REQUIRED_DEFINITIONS -DMINGW_HAS_SECURE_API)
-	endif()
 endif()
 
 if(USE_STATIC_LIBS AND NOT MSVC)
@@ -118,7 +124,8 @@
 link_directories(${Boost_LIBRARY_DIRS})
 include_directories(SYSTEM ${Boost_INCLUDE_DIR})
 
-if(Boost_USE_STATIC_LIBS)
+has_static_libs(Boost Boost_LIBRARIES)
+if(Boost_HAS_STATIC_LIBS)
 	
 	use_static_libs(ZLIB)
 	find_package(ZLIB REQUIRED)
@@ -134,11 +141,33 @@
 	
 endif()
 
-find_package(iconv REQUIRED)
-check_link_library(iconv iconv_LIBRARIES)
-list(APPEND LIBRARIES ${iconv_LIBRARIES})
-include_directories(SYSTEM ${iconv_INCLUDE_DIR})
-add_definitions(${iconv_DEFINITIONS})
+set(INNOEXTRACT_HAVE_ICONV 0)
+set(INNOEXTRACT_HAVE_WIN32_CONV 0)
+set(INNOEXTRACT_HAVE_BUILTIN_CONV ${ENABLE_BUILTIN_CONV})
+if(WIN32 AND (NOT WITH_CONV OR WITH_CONV STREQUAL "win32"))
+	set(INNOEXTRACT_HAVE_WIN32_CONV 1)
+elseif(NOT WITH_CONV OR WITH_CONV STREQUAL "iconv")
+	if(STRICT_USE)
+		set(ICONV_REQUIRED REQUIRED)
+	else()
+		set(ICONV_REQUIRED)
+	endif()
+	find_package(iconv ${ICONV_REQUIRED})
+	if(ICONV_FOUND)
+		check_link_library(iconv iconv_LIBRARIES)
+		list(APPEND LIBRARIES ${iconv_LIBRARIES})
+		include_directories(SYSTEM ${iconv_INCLUDE_DIR})
+		add_definitions(${iconv_DEFINITIONS})
+		set(INNOEXTRACT_HAVE_ICONV 1)
+	endif()
+elseif(WITH_CONV AND NOT WITH_CONV STREQUAL "builtin")
+	message(FATAL_ERROR "Invalid WITH_CONV option: ${WITH_CONV}")
+endif()
+if(NOT INNOEXTRACT_HAVE_ICONV AND NOT INNOEXTRACT_HAVE_WIN32_CONV
+   AND NOT INNOEXTRACT_HAVE_BUILTIN_CONV)
+	message(WARNING "\nBuilding without any charset conversion support.\n"
+	                "Any non-ASCII characters in extracted filenames will be missing.")
+endif()
 
 
 # Set compiler flags
@@ -149,9 +178,9 @@
 	enable_cxx11()
 	check_cxx11("alignof" INNOEXTRACT_HAVE_ALIGNOF)
 	if(WIN32)
-		check_cxx11("std::codecvt_utf8_utf16" INNOEXTRACT_HAVE_STD_CODECVT_UTF8_UTF16)
-	endif()
-	check_cxx11("std::unique_ptr" INNOEXTRACT_HAVE_STD_UNIQUE_PTR)
+		check_cxx11("std::codecvt_utf8_utf16" INNOEXTRACT_HAVE_STD_CODECVT_UTF8_UTF16 1600)
+	endif()
+	check_cxx11("std::unique_ptr" INNOEXTRACT_HAVE_STD_UNIQUE_PTR 1600)
 endif()
 
 # Don't expose internal symbols to the outside world by default
@@ -169,114 +198,194 @@
 
 if(WIN32)
 	# Define this so that we don't accitenally use ANSI functions
+	add_definitions(-DUNICODE)
 	add_definitions(-D_UNICODE)
 endif()
 
 
 # Check for optional functionality and system configuration
 
-check_symbol_exists(isatty "unistd.h" INNOEXTRACT_HAVE_ISATTY)
-if(NOT INNOEXTRACT_HAVE_ISATTY)
-	check_symbol_exists(_isatty "io.h" INNOEXTRACT_HAVE_MS_ISATTY)
-endif()
-check_symbol_exists(ioctl "sys/ioctl.h" INNOEXTRACT_HAVE_IOCTL)
-check_symbol_exists(_mkgmtime64 "time.h" INNOEXTRACT_HAVE_MKGMTIME64)
-if(NOT INNOEXTRACT_HAVE_MKGMTIME64)
+if(NOT WIN32)
+	
+	check_symbol_exists(isatty "unistd.h" INNOEXTRACT_HAVE_ISATTY)
+	check_symbol_exists(ioctl "sys/ioctl.h" INNOEXTRACT_HAVE_IOCTL)
 	check_symbol_exists(timegm "time.h" INNOEXTRACT_HAVE_TIMEGM)
-	if(NOT INNOEXTRACT_HAVE_TIMEGM)
-		check_symbol_exists(_mkgmtime "time.h" INNOEXTRACT_HAVE_MKGMTIME)
-	endif()
-endif()
-check_symbol_exists(_gmtime64_s "time.h" INNOEXTRACT_HAVE_GMTIME64_S)
-if(NOT INNOEXTRACT_HAVE_GMTIME64_S)
 	check_symbol_exists(gmtime_r "time.h" INNOEXTRACT_HAVE_GMTIME_R)
-	if(NOT INNOEXTRACT_HAVE_GMTIME_R)
-		check_symbol_exists(gmtime_s "time.h" INNOEXTRACT_HAVE_GMTIME_S)
-	endif()
-endif()
-if(NOT WIN32)
-	check_symbol_exists(utimensat "sys/stat.h" INNOEXTRACT_HAVE_UTIMENSAT)
 	check_symbol_exists(AT_FDCWD "fcntl.h" INNOEXTRACT_HAVE_AT_FDCWD)
+	if(INNOEXTRACT_HAVE_AT_FDCWD)
+		check_symbol_exists(utimensat "sys/stat.h" INNOEXTRACT_HAVE_UTIMENSAT)
+	endif()
 	if(INNOEXTRACT_HAVE_UTIMENSAT AND INNOEXTRACT_HAVE_AT_FDCWD)
 		set(INNOEXTRACT_HAVE_UTIMENSAT_d 1)
 	else()
+		if(USE_DYNAMIC_UTIMENSAT AND INNOEXTRACT_HAVE_AT_FDCWD)
+			set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS})
+			check_symbol_exists(dlsym "dlfcn.h" INNOEXTRACT_HAVE_DLSYM)
+			check_symbol_exists(RTLD_DEFAULT "dlfcn.h" INNOEXTRACT_HAVE_RTLD_DEFAULT)
+			unset(CMAKE_REQUIRED_LIBRARIES)
+			if(INNOEXTRACT_HAVE_DLSYM AND INNOEXTRACT_HAVE_RTLD_DEFAULT)
+				set(INNOEXTRACT_HAVE_DYNAMIC_UTIMENSAT 1)
+				if(CMAKE_DL_LIBS)
+					list(APPEND LIBRARIES ${CMAKE_DL_LIBS})
+				endif()
+			endif()
+		endif()
 		check_symbol_exists(utimes "sys/time.h" INNOEXTRACT_HAVE_UTIMES)
 	endif()
-endif()
-
-check_symbol_exists(bswap_16 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_16)
-check_symbol_exists(bswap_32 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_32)
-check_symbol_exists(bswap_64 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_64)
+	check_symbol_exists(posix_spawnp "spawn.h" INNOEXTRACT_HAVE_POSIX_SPAWNP)
+	if(NOT INNOEXTRACT_HAVE_POSIX_SPAWNP)
+		check_symbol_exists(fork "unistd.h" INNOEXTRACT_HAVE_FORK)
+		check_symbol_exists(execvp "unistd.h" INNOEXTRACT_HAVE_EXECVP)
+	endif()
+	if(INNOEXTRACT_HAVE_POSIX_SPAWNP OR (INNOEXTRACT_HAVE_FORK AND INNOEXTRACT_HAVE_EXECVP))
+		check_symbol_exists(waitpid "sys/wait.h" INNOEXTRACT_HAVE_WAITPID)
+	endif()
+	
+	if(CMAKE_CXX_COMPILER_ID STREQUAL "PathScale")
+		# EKOPath recognizes these but then fails to link
+	else()
+		check_builtin(INNOEXTRACT_HAVE_BUILTIN_BSWAP16 "__builtin_bswap16(0)")
+		check_builtin(INNOEXTRACT_HAVE_BUILTIN_BSWAP32 "__builtin_bswap32(0)")
+		check_builtin(INNOEXTRACT_HAVE_BUILTIN_BSWAP64 "__builtin_bswap64(0)")
+	endif()
+	if(NOT INNOEXTRACT_HAVE_BUILTIN_BSWAP16)
+		check_symbol_exists(bswap_16 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_16)
+	endif()
+	if(NOT INNOEXTRACT_HAVE_BUILTIN_BSWAP32)
+		check_symbol_exists(bswap_32 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_32)
+	endif()
+	if(NOT INNOEXTRACT_HAVE_BUILTIN_BSWAP64)
+		check_symbol_exists(bswap_64 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_64)
+	endif()
+	
+endif()
 
 
 # All sources:
 
+set(DOCUMENTATION 0) # never build these
+
 set(INNOEXTRACT_SOURCES
 	
+	src/index.hpp if DOCUMENTATION
+	src/release.hpp
+	
+	src/cli/debug.hpp
+	src/cli/debug.cpp if DEBUG
+	src/cli/extract.hpp
+	src/cli/extract.cpp
+	src/cli/gog.hpp
+	src/cli/gog.cpp
 	src/cli/main.cpp
 	
+	src/crypto/adler32.hpp
 	src/crypto/adler32.cpp
+	src/crypto/checksum.hpp
 	src/crypto/checksum.cpp
+	src/crypto/crc32.hpp
 	src/crypto/crc32.cpp
 	src/crypto/hasher.cpp
+	src/crypto/hasher.cpp
+	src/crypto/iteratedhash.hpp
+	src/crypto/md5.hpp
 	src/crypto/md5.cpp
+	src/crypto/sha1.hpp
 	src/crypto/sha1.cpp
 	
+	src/loader/exereader.hpp
 	src/loader/exereader.cpp
+	src/loader/offsets.hpp
 	src/loader/offsets.cpp
 	
+	src/setup/component.hpp
 	src/setup/component.cpp
+	src/setup/data.hpp
 	src/setup/data.cpp
+	src/setup/delete.hpp
 	src/setup/delete.cpp
+	src/setup/directory.hpp
 	src/setup/directory.cpp
+	src/setup/expression.hpp
 	src/setup/expression.cpp
+	src/setup/file.hpp
 	src/setup/file.cpp
+	src/setup/filename.hpp
 	src/setup/filename.cpp
+	src/setup/header.hpp
 	src/setup/header.cpp
+	src/setup/icon.hpp
 	src/setup/icon.cpp
+	src/setup/info.hpp
 	src/setup/info.cpp
+	src/setup/ini.hpp
 	src/setup/ini.cpp
+	src/setup/item.hpp
 	src/setup/item.cpp
+	src/setup/language.hpp
 	src/setup/language.cpp
+	src/setup/message.hpp
 	src/setup/message.cpp
+	src/setup/permission.hpp
 	src/setup/permission.cpp
+	src/setup/registry.hpp
 	src/setup/registry.cpp
+	src/setup/run.hpp
 	src/setup/run.cpp
+	src/setup/task.hpp
 	src/setup/task.cpp
+	src/setup/type.hpp
 	src/setup/type.cpp
+	src/setup/version.hpp
 	src/setup/version.cpp
+	src/setup/windows.hpp
 	src/setup/windows.cpp
 	
+	src/stream/block.hpp
 	src/stream/block.cpp
+	src/stream/checksum.hpp
+	src/stream/chunk.hpp
 	src/stream/chunk.cpp
+	src/stream/exefilter.hpp
+	src/stream/file.hpp
 	src/stream/file.cpp
-	
+	src/stream/lzma.hpp
+	src/stream/lzma.cpp if INNOEXTRACT_HAVE_LZMA
+	src/stream/restrict.hpp
+	src/stream/slice.hpp
 	src/stream/slice.cpp
+	
+	src/util/align.hpp
+	src/util/ansi.hpp
+	src/util/boostfs_compat.hpp
+	src/util/console.hpp
 	src/util/console.cpp
+	src/util/encoding.hpp
+	src/util/encoding.cpp
+	src/util/endian.hpp
+	src/util/enum.hpp
+	src/util/flags.hpp
+	src/util/fstream.hpp
+	src/util/load.hpp
 	src/util/load.cpp
+	src/util/log.hpp
 	src/util/log.cpp
+	src/util/math.hpp
+	src/util/output.hpp
+	src/util/process.hpp
+	src/util/process.cpp
+	src/util/storedenum.hpp
+	src/util/time.hpp
 	src/util/time.cpp
+	src/util/types.hpp
+	src/util/unique_ptr.hpp
+	src/util/windows.hpp
+	src/util/windows.cpp if WIN32
 	
 )
 
-if(DEBUG)
-	list(APPEND INNOEXTRACT_SOURCES src/cli/debug.cpp)
-endif()
-
-if(LZMA_FOUND)
-	list(APPEND INNOEXTRACT_SOURCES src/stream/lzma.cpp)
-endif()
-
-if(WIN32)
-	list(APPEND INNOEXTRACT_SOURCES src/util/windows.cpp)
-endif()
-
-file(GLOB_RECURSE ALL_INCLUDES "${CMAKE_SOURCE_DIR}/src/*.hpp")
-
-list(SORT INNOEXTRACT_SOURCES)
-list(SORT ALL_INCLUDES)
-
-list(APPEND CHECKED_SOURCES ${INNOEXTRACT_SOURCES})
+filter_list(INNOEXTRACT_SOURCES ALL_INNOEXTRACT_SOURCES)
+
+create_source_groups(ALL_INNOEXTRACT_SOURCES)
 
 
 # Prepare generated files
@@ -288,12 +397,12 @@
 set(VERSION_FILE "${CMAKE_BINARY_DIR}/release.cpp")
 set(VERSION_SOURCES VERSION "VERSION" LICENSE "LICENSE")
 version_file("src/release.cpp.in" "${VERSION_FILE}" "${VERSION_SOURCES}" ".git")
-list(APPEND INNOEXTRACT_SOURCES "${VERSION_FILE}")
+list(APPEND INNOEXTRACT_SOURCES ${VERSION_FILE})
 
 
 # Main targets
 
-add_executable(innoextract ${INNOEXTRACT_SOURCES} ${ALL_INCLUDES})
+add_executable(innoextract ${INNOEXTRACT_SOURCES})
 target_link_libraries(innoextract ${LIBRARIES})
 
 install(TARGETS innoextract RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
@@ -303,24 +412,5 @@
 
 # Additional targets.
 
-add_style_check_target(style "${CHECKED_SOURCES}" "${ALL_INCLUDES}")
-
-add_doxygen_target(doc "doc/Doxyfile.in" "VERSION" ".git" "${CMAKE_BINARY_DIR}/doc")
-
-
-# Print a configuration summary
-
-message("")
-message("Configuration:")
-message(" - Build type: ${CMAKE_BUILD_TYPE}")
-print_configuration("LZMA decompression" FIRST
-	INNOEXTRACT_HAVE_LZMA "enabled"
-	1                     "disabled"
-)
-print_configuration("File time precision" FIRST
-	INNOEXTRACT_HAVE_UTIMENSAT_d "nanoseconds"
-	WIN32                        "100-nanoseconds"
-	INNOEXTRACT_HAVE_UTIMES      "microseconds"
-	1                            "seconds"
-)
-message("")
+add_style_check_target(style "${ALL_INNOEXTRACT_SOURCES}" innoextract)
+
