=== debian/changelog ===
innoextract (1.5-1) unstable; urgency=low

  * New upstream release (Closes: #799985)

 -- Lennart Weller <lhw@ring0.de>  Fri, 25 Sep 2015 08:37:46 +0200
