=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/innoextract.git
 Homepage: https://github.com/dscharrer/InnoExtract
@@ -26,4 +26,4 @@
  Inno Setup is a tool to create installers for Microsoft Windows applications.
  Inno Extracts allows one to extract such installers under non-windows systems
  without running the actual installer using wine. Inno Extract currently
- supports installers created by Inno Setup 1.2.10 to 5.4.3.
+ supports installers created by Inno Setup 1.2.10 to 5.5.5.
