## innoextract 1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,16 @@
 
 cmake_minimum_required(VERSION 2.8)
 
+if(CMAKE_VERSION VERSION_GREATER 3.4)
+	cmake_policy(VERSION 3.4)
+else()
+	cmake_policy(VERSION ${CMAKE_VERSION})
+endif()
+
 
 # Define configuration options
 
+option(STRICT_USE "Abort if there are missing optional dependencies"  OFF)
 option(USE_LZMA "Build lzma decompression support" ON)
 set(WITH_CONV CACHE STRING "The library to use for charset conversions")
 option(ENABLE_BUILTIN_CONV "Build internal charset conversion routines" ON)
@@ -172,7 +179,7 @@
 
 # Set compiler flags
 
-if(${Boost_VERSION} LESS 104800)
+if(Boost_VERSION LESS 104800)
 	# Older Boost versions don't work with C++11
 elseif(USE_CXX11)
 	enable_cxx11()
@@ -191,7 +198,7 @@
 
 # Older glibc versions won't provide some useful symbols by default - request them
 # This flag is currently also set by gcc when compiling C++, but not for plain C
-if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+if(CMAKE_SYSTEM_NAME MATCHES "Linux")
 	set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE=1")
 	add_definitions(-D_GNU_SOURCE=1)
 endif()
@@ -407,10 +414,3 @@
 
 install(TARGETS innoextract RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
 
-install(FILES doc/innoextract.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 OPTIONAL)
-
-
-# Additional targets.
-
-add_style_check_target(style "${ALL_INNOEXTRACT_SOURCES}" innoextract)
-
