=== debian/changelog ===
innoextract (1.6-1build3) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:16:53 +0000

innoextract (1.6-1build2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:24:15 +0000

innoextract (1.6-1build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:19:28 +0000

innoextract (1.6-1) unstable; urgency=low

  * New upstream release
  * Added build-hardening flags
  * Updated Homepage and Vcs-URLs
  * Updated debian Standards-Version
  * Updated watch file with PGP support and releases instead of tags

 -- Lennart Weller <lhw@ring0.de>  Fri, 08 Apr 2016 11:52:16 +0200
