=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: innoextract
 Section: utils
 Priority: extra
-Maintainer: Lennart Weller <lhw@ring0.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
-Standards-Version: 3.9.6
-Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/innoextract.git
-Homepage: https://github.com/dscharrer/InnoExtract
+Standards-Version: 3.9.7
+Vcs-git: https://anonscm.debian.org/git/collab-maint/innoextract.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/innoextract.git
+Homepage: http://constexpr.org/innoextract/
 Build-Depends: cmake,
                debhelper (>= 9),
                dpkg-dev (>= 1.16.1~),
@@ -26,4 +27,4 @@
  Inno Setup is a tool to create installers for Microsoft Windows applications.
  Inno Extracts allows one to extract such installers under non-windows systems
  without running the actual installer using wine. Inno Extract currently
- supports installers created by Inno Setup 1.2.10 to 5.5.5.
+ supports installers created by Inno Setup 1.2.10 to 5.5.8.
