=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/,pgpsigurlmangle=s/$/.sig/ \
	https://github.com/dscharrer/innoextract/releases .*?/(?:\d\S*)/innoextract-(\d\S*)\.tar\.gz
