## innoextract 1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,18 +11,30 @@
 
 # Define configuration options
 
+macro(suboption _var _comment _type _default)
+	if(NOT DEFINED ${_var})
+		set(${_var} "${_default}")
+	else()
+		set(${_var} "${${_var}}" CACHE ${_type} "${_comment}")
+	endif()
+endmacro()
+
 option(STRICT_USE "Abort if there are missing optional dependencies"  OFF)
-option(USE_LZMA "Build lzma decompression support" ON)
+option(USE_ARC4 "Build ARC4 decryption support" ON)
+option(USE_LZMA "Build LZMA decompression support" ON)
 set(WITH_CONV CACHE STRING "The library to use for charset conversions")
-option(ENABLE_BUILTIN_CONV "Build internal charset conversion routines" ON)
 option(DEBUG_EXTRA "Expensive debug options" OFF)
 option(SET_WARNING_FLAGS "Adjust compiler warning flags" ON)
 option(SET_OPTIMIZATION_FLAGS "Adjust compiler optimization flags" ON)
-option(USE_CXX11 "Try to use C++11 if available" ON)
+suboption(CXX_STD_VERSION "Maximum C++ standard version to enable" STRING 2017)
 option(USE_DYNAMIC_UTIMENSAT "Dynamically load utimensat if not available at compile time" OFF)
-if(NOT DEFINED DEBUG AND CMAKE_BUILD_TYPE STREQUAL "Debug")
-	set(DEBUG 1)
-endif()
+
+set(default_DEBUG OFF)
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+	set(default_DEBUG ON)
+endif()
+suboption(DEBUG "Build with debug output" BOOL ${default_DEBUG})
+
 if(DEBUG)
 	add_definitions(-DDEBUG=1)
 endif()
@@ -61,11 +73,11 @@
 
 include(CheckSymbolExists)
 
-set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake") # For custom cmake modules
+set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake") # For custom cmake modules
 include(BuildType)
 include(CompileCheck)
 include(CreateSourceGroups)
-include(CXX11Check)
+include(CXXVersionCheck)
 include(Doxygen)
 include(FilterList)
 include(PrintConfiguration)
@@ -106,6 +118,10 @@
 
 unset(LIBRARIES)
 
+if(USE_ARC4)
+	set(INNOEXTRACT_HAVE_ARC4 1)
+endif()
+
 if(USE_LZMA)
 	find_package(LZMA REQUIRED)
 	check_link_library(LZMA LZMA_LIBRARIES)
@@ -150,7 +166,6 @@
 
 set(INNOEXTRACT_HAVE_ICONV 0)
 set(INNOEXTRACT_HAVE_WIN32_CONV 0)
-set(INNOEXTRACT_HAVE_BUILTIN_CONV ${ENABLE_BUILTIN_CONV})
 if(WIN32 AND (NOT WITH_CONV OR WITH_CONV STREQUAL "win32"))
 	set(INNOEXTRACT_HAVE_WIN32_CONV 1)
 elseif(NOT WITH_CONV OR WITH_CONV STREQUAL "iconv")
@@ -170,19 +185,14 @@
 elseif(WITH_CONV AND NOT WITH_CONV STREQUAL "builtin")
 	message(FATAL_ERROR "Invalid WITH_CONV option: ${WITH_CONV}")
 endif()
-if(NOT INNOEXTRACT_HAVE_ICONV AND NOT INNOEXTRACT_HAVE_WIN32_CONV
-   AND NOT INNOEXTRACT_HAVE_BUILTIN_CONV)
-	message(WARNING "\nBuilding without any charset conversion support.\n"
-	                "Any non-ASCII characters in extracted filenames will be missing.")
-endif()
 
 
 # Set compiler flags
 
 if(Boost_VERSION LESS 104800)
 	# Older Boost versions don't work with C++11
-elseif(USE_CXX11)
-	enable_cxx11()
+elseif(NOT CXX_STD_VERSION LESS 2011)
+	enable_cxx_version(${CXX_STD_VERSION})
 	check_cxx11("alignof" INNOEXTRACT_HAVE_ALIGNOF)
 	if(WIN32)
 		check_cxx11("std::codecvt_utf8_utf16" INNOEXTRACT_HAVE_STD_CODECVT_UTF8_UTF16 1600)
@@ -248,6 +258,10 @@
 		check_symbol_exists(waitpid "sys/wait.h" INNOEXTRACT_HAVE_WAITPID)
 	endif()
 	
+endif()
+
+if(NOT MSVC)
+	
 	if(CMAKE_CXX_COMPILER_ID STREQUAL "PathScale")
 		# EKOPath recognizes these but then fails to link
 	else()
@@ -283,10 +297,14 @@
 	src/cli/extract.cpp
 	src/cli/gog.hpp
 	src/cli/gog.cpp
+	src/cli/goggalaxy.hpp
+	src/cli/goggalaxy.cpp
 	src/cli/main.cpp
 	
 	src/crypto/adler32.hpp
 	src/crypto/adler32.cpp
+	src/crypto/arc4.hpp if INNOEXTRACT_HAVE_ARC4
+	src/crypto/arc4.cpp if INNOEXTRACT_HAVE_ARC4
 	src/crypto/checksum.hpp
 	src/crypto/checksum.cpp
 	src/crypto/crc32.hpp
@@ -401,16 +419,8 @@
 
 configure_file("src/configure.hpp.in" "configure.hpp")
 
-set(VERSION_FILE "${CMAKE_BINARY_DIR}/release.cpp")
+set(VERSION_FILE "${PROJECT_BINARY_DIR}/release.cpp")
 set(VERSION_SOURCES VERSION "VERSION" LICENSE "LICENSE")
-version_file("src/release.cpp.in" "${VERSION_FILE}" "${VERSION_SOURCES}" ".git")
+version_file("src/release.cpp.in" ${VERSION_FILE} "${VERSION_SOURCES}" ".git")
 list(APPEND INNOEXTRACT_SOURCES ${VERSION_FILE})
 
-
-# Main targets
-
-add_executable(innoextract ${INNOEXTRACT_SOURCES})
-target_link_libraries(innoextract ${LIBRARIES})
-
-install(TARGETS innoextract RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-
