=== debian/changelog ===
innoextract (1.7-2) unstable; urgency=medium

  * upstream patch: fix larger than 2GiB slices (Closes: #903312)

 -- Lennart Weller <lhw@ring0.de>  Fri, 02 Nov 2018 08:59:05 +0100

innoextract (1.7-1) unstable; urgency=medium

  [ Lennart Weller ]
  * new upstream release (Closes: #902579)

  [ Helmut Grohne ]
  * Fix FTCBFS: Pass cross compilers to cmake (Closes: #870652)

 -- Lennart Weller <lhw@ring0.de>  Sun, 01 Jul 2018 20:01:04 +0200
