=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: innoextract
 Section: utils
-Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Lennart Weller <lhw@ring0.de>
+Priority: optional
+Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
-Standards-Version: 3.9.7
-Vcs-git: https://anonscm.debian.org/git/collab-maint/innoextract.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/innoextract.git
+Standards-Version: 4.2.1
+Vcs-Browser: https://salsa.debian.org/lhw-guest/innoextract
+Vcs-git: https://salsa.debian.org/lhw-guest/innoextract.git
 Homepage: http://constexpr.org/innoextract/
 Build-Depends: cmake,
                debhelper (>= 9),
